/**
 * Copyright (c) 2007, Jeong Ho Wook.
 * E-mail : sophistlv@yahoo.co.kr
 * All free. ^^*
 * Version 0.0.1
 */

/**
 * web.util.element class
 * dynamic ü  class
 */
web.util.element = {

/**
 * 콺 Ŭ ġؾ ϴ ü x ǥ
 */
    nPosX:0,

/**
 * 콺 Ŭ ġؾ ϴ ü y ǥ
 */
    nPosY:0,

/**
 * layer ġ ̼
 */
    nPrivatePos:5,

/**
 *  layer ü
 * array  ؾ
 */
    oLayerDiv:null,

/**
 *  layer  visibility 
 */
    bLayerDiv:false,

/**
 * layer θ ϱ  html ڵ
 */
    sLayerDiv:"",

/**
 * form ü
 */
    oForm:null,

/**
 * form ü 
 */
    aFormData:[], 

/**
 * form ü  element
 */
    aFormElem:[],

/**
 *  ȣ  time interval
 */
    nTimeout:500,

/**
 * this is set position function for layer.
 *
 * @param object oObj this object
 * @param object oEvent event handler on firefox
 */
    set_layer_xy:function( oObj, oEvent ) {
        var oParent;

        this.nPosX = 0;
        this.nPosY = 0;

        if ( typeof(oEvent) == "object" ) {
            this.nPosX = oEvent.pageX + document.body.scrollLeft - this.nPrivatePos;
            this.nPosY = oEvent.pageY - this.nPrivatePos;
        } else {
            this.nPosX = event.x + document.body.scrollLeft - this.nPrivatePos;
            this.nPosY = event.y - this.nPrivatePos;
        }

        oParent = oObj;
        for ( i=0; true; i++ ) {
            if ( oParent.tagName == "BODY" ) {
                break;
            } else {
                oParent = oParent.offsetParent;
                this.nPosX += oParent.offsetLeft;
                this.nPosY += oParent.offsetTop;
            }
        }
    },

/**
 * this is create element function.
 *
 * @param string sElType element types (where is body or form)
 * @param array element's value
 * @param object oForm form object for element of form.
 * @return object
 */
    set_create_element:function( sElType, aElValue, oForm ) {
        var oElObj;

        oElObj = document.createElement(aElValue["type"]);
        oElObj.setAttribute("id", aElValue["id"]);
        oElObj.setAttribute("name", aElValue["name"]);

        switch ( aElValue["type"] ) {
            case "iframe" :
                oElObj.setAttribute("src", aElValue["src"]);
                var aElStyle = aElValue["style"]["list"].split(",");
    
                for ( i=0; i<aElStyle.length; i++ ){
                    if ( typeof(oElObj.style.setProperty) == "function" ) {
                        oElObj.style.setProperty(aElStyle[i], aElValue["style"][aElStyle[i]], null);
                    } else {
                        oElObj.style[aElStyle[i]] = aElValue["style"][aElStyle[i]];
                    }
                }
                break;
            case "div" :
            case "layer" :
                var aElStyle = aElValue["style"]["list"].split(",");
    
                for ( i=0; i<aElStyle.length; i++ ){
                    if ( typeof(oElObj.style.setProperty) == "function" ) {
                        oElObj.style.setProperty(aElStyle[i], aElValue["style"][aElStyle[i]], null);
                    } else {
                        oElObj.style[aElStyle[i]] = aElValue["style"][aElStyle[i]];
                    }
                }
                break;
            case "form" :
                break;
            case "input" :
                oElObj.setAttribute("type", aElValue["types"]);
                oElObj.setAttribute("value", aElValue["value"]);
                break;
            case "textarea" :
                var aElStyle = aElValue["style"]["list"].split(",");
    
                for ( i=0; i<aElStyle.length; i++ ){
                    if ( typeof(oElObj.style.setProperty) == "function" ) {
                        oElObj.style.setProperty(aElStyle[i], aElValue["style"][aElStyle[i]], null);
                    } else {
                        oElObj.style[aElStyle[i]] = aElValue["style"][aElStyle[i]];
                    }
                }

                oElObj.setAttribute("value", aElValue["value"]);
                oElObj.setAttribute("cols", aElValue["cols"]);
                oElObj.setAttribute("rows", aElValue["rows"]);
                break;
        }
    
        switch ( sElType ) {
            case "body" :
                document.body.appendChild(oElObj);
                break;
            case "form" :
                oForm.appendChild(oElObj);
                break;
        }

        return oElObj;
    },

/**
 * this is get data function. ( iframe, form )
 *
 * @param string sElName element id
 * @param string sFormElList form element id list
 * @return string or array sLayerDiv or aFormData on this global variable
 */
    get_data:function( sElName, sFormElList ) {
        var aFormElName = new Array();

        if ( typeof(self.frames[sElName]) == "unknown" ) {
            this.set_timeout("get_data", sElName, sFormElList);
        } else {
            if ( typeof(self.frames[sElName]) == "object" ) {
                if ( typeof(self.frames[sElName].document) == "unknown" ) {
                    this.set_timeout("get_data", sElName, sFormElList);
                } else {
                    if ( typeof(self.frames[sElName].document) == "object" ) {
                        if ( self.frames[sElName].document.body == null ) {
                            this.set_timeout("get_data", sElName, sFormElList);
                        } else {
                            if ( self.frames[sElName].document.body.innerHTML == "" ) {
                                this.set_timeout("get_data", sElName, sFormElList);
                            } else {
                                // display string
                                this.sLayerDiv = self.frames[sElName].document.body.innerHTML;
                                // read form data
                                if ( typeof(sFormElList) != "undefined" ) {
                                    aFormElName = sFormElList.split(",");
                                }
    
                                for ( i=0; i<aFormElName.length; i++ ) {
                                    this.aFormData[aFormElName[i]] = self.frames[sElName].document.getElementById(aFormElName[i]).value;
                                }
                            }
                        }
                    } else {
                        this.set_timeout("get_data", sElName, sFormElList);
                    }
                }
            } else {
                this.set_timeout("get_data", sElName, sFormElList);
            }
        }
    },

    set_presentation:function() {
        if ( typeof(this.sLayerDiv) == "undefined" || this.sLayerDiv == "") {
            this.set_timeout("set_presentation");
        } else {
            this.oLayerDiv.innerHTML = this.sLayerDiv;
            this.oLayerDiv.style.left = this.nPosX;
            this.oLayerDiv.style.top = this.nPosY;

            this.oLayerDiv.style.display = "block";
            this.oLayerDiv.style.visibility = "visible";
        }
    },

/**
 * this is wrapped function of the setTimeout.
 *
 * @param string sFunc function name for execution
 * @param string sElName function's parameter
 * @param stirng sFormElList form's element name
 */
    set_timeout:function( sFunc, sElName, sFormElList ) {
        var oThis = this;
        setTimeout(
            function(){
                oThis[sFunc](sElName, sFormElList);
            }, this.nTimeout );
    },

/**
 * this is remove element function.
 *
 * @param string sElType remove type's
 * @param object oElObj remove object
 * @param object oForm form object
 */
    set_remove_element:function( sElType, oElObj, oForm ) {
        if ( oElObj != null && typeof(oElObj) == "object" ) {
            switch ( sElType ) {
                case "body" :
                    switch ( oElObj.tagName ) {
                        case "DIV" :
                        case "LAYER" :
                            oElObj.style.display = "none";
                            oElObj.style.visibility = "hidden";
                            break;
                    }
    
                    document.body.removeChild(oElObj);
                    break;
                case "form" :
                    oForm.removeChild(oElObj);
                    break;
            }
        }
    }
}

web.namespace("web.util.element");

